/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PROCESSO                                                 */
/* Tabela : INDICADOR                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 09/06/2008 - Luan Alison Cardoso de Carvalho                               */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_INDICADOR
BEFORE INSERT OR UPDATE OR DELETE
ON INDICADOR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUINDICA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDINDICADOR,0) <> NVL(:NEW.CDINDICADOR,0)) OR
         (NVL(:OLD.SGUNIDADE,0) <> NVL(:NEW.SGUNIDADE,0)) OR
         (NVL(:OLD.CDCARGO,0) <> NVL(:NEW.CDCARGO,0)) OR
         (NVL(:OLD.NMINDICADOR,0) <> NVL(:NEW.NMINDICADOR,0)) OR
         (NVL(:OLD.DSMETAMININD,0) <> NVL(:NEW.DSMETAMININD,0)) OR
         (NVL(:OLD.DSOBJETIVOIND,0) <> NVL(:NEW.DSOBJETIVOIND,0)) OR
         (NVL(:OLD.DSQUESTAOIND,0) <> NVL(:NEW.DSQUESTAOIND,0)) OR
         (NVL(:OLD.DSCALCULOIND,0) <> NVL(:NEW.DSCALCULOIND,0)) OR
         (NVL(:OLD.IDPERICOLETAIND,0) <> NVL(:NEW.IDPERICOLETAIND,0)) OR
         (NVL(:OLD.DSFONTEMEDIDIND,0) <> NVL(:NEW.DSFONTEMEDIDIND,0)) OR
         (NVL(:OLD.DSLOCALDIVULIND,0) <> NVL(:NEW.DSLOCALDIVULIND,0)) OR
         (NVL(:OLD.NMREUNIAOANALIS,0) <> NVL(:NEW.NMREUNIAOANALIS,0)) OR
         (NVL(:OLD.DSACOESIND,0) <> NVL(:NEW.DSACOESIND,0)) OR
         (NVL(:OLD.DSCRITDECISIND,0) <> NVL(:NEW.DSCRITDECISIND,0)) THEN
         :NEW.DTULTATUINDICA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('INDICADOR', '', 'CDINDICADOR='||:OLD.CDINDICADOR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE INDICADOR MODIFY DTULTATUINDICA DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_INDICADOR','5.03.010'); END;
/
