// FILE: ./assets/js/repositories/Cdp05000_ProcessoFabricacao_Repository.js
function Cdp05000_ProcessoFabricacao_Repository(restEngine, localStorageEngine) {
	this.retornaUnidadeLogada = function() {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("cadCdp#/crud/filial", filter);
    };
    
    this.saveVigencia = function(dataSet) {
        return restEngine.post('cadCdp#/crud/espeprod_operador/save', {
            "requestType": "DataSet",
            "dataset": dataSet
        });
    };
    
    this.saveProcesso = function(dataSet) {
        return restEngine.post('cadCdp#/crud/operador_tprocfabrica_procfabrica/save', {
            "requestType": "DataSet",
            "dataset": dataSet
        });
    };
    
    this.saveComposicao = function(dataSet) {
        return restEngine.post('cadCdp#/crud/tcomppro_tipocomp/save', {
            "requestType": "DataSet",
            "dataset": dataSet
        });
    };
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Cdp05000_ProcessoFabricacao_Repository', Cdp05000_ProcessoFabricacao_Repository);
});

// FILE: ./assets/js/repositories/QPR01000_Parametros_Qualidade_Producao_Repository.js
var QPR01000_Parametros_Qualidade_Producao_Repository = function(restEngine) {
  
  this.findProxConsulta = function(filter) {
      
    return restEngine.post('cdp#/findProxConsulta', {
           'requestType': 'DataSet', 
           'dataset': [filter.currentRow]
    });
      
      
  };
  
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('QPR01000_Parametros_Qualidade_Producao_Repository', QPR01000_Parametros_Qualidade_Producao_Repository);
});

// FILE: ./assets/js/repositories/QPR01900_Inspecao_Digital_Repository.js
var QPR01900_Inspecao_Digital_Repository = function(restEngine) {

    this.changeQuestion = function(row){
        return restEngine.post('cdp#/InspecaoDigital/changeQuestion', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.searchTarefaQuestao = function(row){
        return restEngine.post('cdp#/InspecaoDigital/searchTarefaQuestao', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.sendChanges = function(row){
        return restEngine.post('cdp#/InspecaoDigital/sendChanges', {
            "requestType": "Row",
            "row": row
        });
    };
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('QPR01900_Inspecao_Digital_Repository', QPR01900_Inspecao_Digital_Repository);
});

// FILE: ./assets/js/repositories/cdp00500_etapa_de_producao_Repository.js
var cdp00500_etapa_de_producao_Repository = function (restEngine) {

    this.save = function(row) {
        return restEngine.post('cadCdp#/saveEtapa', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp00500_etapa_de_producao_Repository', cdp00500_etapa_de_producao_Repository);
});

// FILE: ./assets/js/services/Cdp05000_ProcessoFabricacao_Service.js
var Cdp05000_ProcessoFabricacao_Service = function(Cdp05000_ProcessoFabricacao_Repository){

	this.retornaUnidadeLogada = function(){
		return Cdp05000_ProcessoFabricacao_Repository.retornaUnidadeLogada();
	};
	
	this.saveVigencia = function(dataSet){
	    return Cdp05000_ProcessoFabricacao_Repository.saveVigencia(dataSet);
	};
	
	this.saveProcesso = function(dataSet){
	    return Cdp05000_ProcessoFabricacao_Repository.saveProcesso(dataSet);
	};
	
	this.saveComposicao = function(dataSet){
	    return Cdp05000_ProcessoFabricacao_Repository.saveComposicao(dataSet);
	};
};
 Configuration(function (ContextRegister){
    ContextRegister.register('Cdp05000_ProcessoFabricacao_Service', Cdp05000_ProcessoFabricacao_Service);
});

// FILE: ./assets/js/services/QPR01000_Parametros_Qualidade_Producao_Service.js
var QPR01000_Parametros_Qualidade_Producao_Service = function(QPR01000_Parametros_Qualidade_Producao_Repository) {
    
    this.findProxConsulta = function(filter) {
        return QPR01000_Parametros_Qualidade_Producao_Repository.findProxConsulta(filter);
    };
    
};


Configuration(function(ContextRegister) {
    ContextRegister.register('QPR01000_Parametros_Qualidade_Producao_Service', QPR01000_Parametros_Qualidade_Producao_Service);
});

// FILE: ./assets/js/services/QPR01900_Inspecao_Digital_Service.js
var QPR01900_Inspecao_Digital_Service = function(QPR01900_Inspecao_Digital_Repository) {
    
    this.changeQuestion = function(row) {
        return QPR01900_Inspecao_Digital_Repository.changeQuestion(row);
    };
    
    this.searchTarefaQuestao = function(row) {
        return QPR01900_Inspecao_Digital_Repository.searchTarefaQuestao(row);
    };
    
    this.sendChanges = function(row) {
        return QPR01900_Inspecao_Digital_Repository.sendChanges(row);
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('QPR01900_Inspecao_Digital_Service', QPR01900_Inspecao_Digital_Service);
});

// FILE: ./assets/js/services/cdp00500_etapa_de_producao_Service.js
var cdp00500_etapa_de_producao_Service = function(cdp00500_etapa_de_producao_Repository){

  this.salvarEtapa = function(row){
   return cdp00500_etapa_de_producao_Repository.save(row);
  };
  
 
};

 Configuration(function (ContextRegister){
    ContextRegister.register('cdp00500_etapa_de_producao_Service', cdp00500_etapa_de_producao_Service);
});



// FILE: ./assets/js/controllers/Cdp05000_ProcessoFabricacao_Controller.js
function Cdp05000_ProcessoFabricacao_Controller (ScreenService, templateManager, General, ZhFilterPreferences, Cdp05000_ProcessoFabricacao_Service, ZHPromise, maskEngine, ZhUtil, metaDataFactory, restEngine){
	
	this.newRow = function(widget){
		widget.newRow();	
	};
	
	this.openNewInsumo = function(){
		var widget = templateManager.container.getWidget('insumosComposicao_new');
		ScreenService.openSwipe(widget).then(function(){
			// General.widgetNewRow(widget);
			
			widget.newRow();
        });
	};

	this.getFieldValue = function(fieldName, widgetName){
		return templateManager.container.getWidget(widgetName).getField(fieldName).value();
	};

	this.openSwipe = function(){
		var widget = templateManager.container.getWidget('widgetTabbed');
		ScreenService.openSwipe(widget).then(function(){
			
        });
	};
	
	this.setDefaultFilialFilter = function() {
		var widget = templateManager.container.getWidget('processoFabricacao');
        Cdp05000_ProcessoFabricacao_Service.retornaUnidadeLogada().then(function(filial){
            widget.currentRow.CDFILIAL		= filial[0].CDFILIAL;
            widget.currentRow.NMFILIAL		= filial[0].NMFILIAL;
            widget.currentRow.NMRAZSOCFILI	= filial[0].NMRAZSOCFILI;
            widget.currentRow.IDCNTRRESC	= filial[0].IDCNTRRESC;
            widget.currentRow.CDFILCENTPME	= filial[0].CDFILCENTPME;
        });
    };
	
	this.openFilter = function(widget) {
        var rowsToSet = {};
        Cdp05000_ProcessoFabricacao_Service.retornaUnidadeLogada().then(function(filial){
            rowsToSet.CDFILIAL = filial[0].CDFILIAL;
            rowsToSet.NMFILIAL = filial[0].NMFILIAL;
            ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
	    });
    };
    
    this.saveVigenciaEdit = function(widgetItem){
        if(widgetItem.isValid()){
            var rows = widgetItem.dataSource.data;
            
            rows = rows.filter(function(row){
                return row.changed === true && (!row.__is_new /*|| rowEditedInline(row)*/);
            });

            Cdp05000_ProcessoFabricacao_Service.saveVigencia(rows).then(function(success) {
                widgetItem.reload();
                widgetItem.list();
            },
            function(error){
                ScreenService.showMessage(error.data.error);
            });
        }
    };
    
    this.saveProcessoEdit = function(widgetItem){
        if(widgetItem.isValid()){
            var rows = widgetItem.dataSource.data;
            
            rows = rows.filter(function(row){
                return row.changed === true && (!row.__is_new /*|| rowEditedInline(row)*/);
            });

            Cdp05000_ProcessoFabricacao_Service.saveProcesso(rows).then(function(success) {
                widgetItem.reload();
                widgetItem.list();
            },
            function(error){
                ScreenService.showMessage(error.data.error);
            });
        }
    };
    
    this.saveComposicaoEdit = function(widgetItem){
        // if(widgetItem.isValid()){
        //     var rows = widgetItem.dataSource.data;
            
        //     rows = rows.filter(function(row){
        //         return row.changed === true && (!row.__is_new /*|| rowEditedInline(row)*/);
        //     });

        //     Cdp05000_ProcessoFabricacao_Service.saveComposicao(rows).then(function(success) {
        //         widgetItem.reload();
        //         widgetItem.list();
        //     },
        //     function(error){
        //         ScreenService.showMessage(error.data.error);
        //     });
        // }
    };
    
    this.saveNewInForm = function (widget) {
		var deferred = ZHPromise.defer();

		if (widget.isValid()) {
			widget.currentRow.changed = true;

			if (!widget.currentRow.__is_new)
				widget.currentRow.__is_new = false;
			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
				widget.currentRow.__new_code_interval = paramsNewCode.__new_code_interval || 1;
				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
				widget.currentRow.__new_code_column_size = widget.paramsNewCode.__new_code_column_size || 10;
				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
                if (!widget.currentRow.__columns_to_return && widget.paramsNewCode && widget.paramsNewCode.__columns_to_return)
                	widget.currentRow.__columns_to_return = widget.paramsNewCode.__columns_to_return;
			}

			widget.saveRow().then(function (response) {
				widget.currentRow.changed = false;
				delete widget.backupRow;

				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
					widget.view();

					var widgets = widget.parent.widgets;
					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
				} else {
					if (widget.currentRow.__is_new) {
						// ScreenService.closeSwipe();
						widget.list();
					} else widget.view();

					General.changeWidgetAcessibility(widget.widgets, true);
				}

				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
				else widget.reload();

				deferred.resolve(response);
			}.bind(this), function (error) {
				var errorMessage = 'Timeout';

				if (error.data) errorMessage = error.data.error;

				ScreenService.showMessage(errorMessage);
				deferred.reject(errorMessage);
			});
		} else deferred.reject("Preencha todos os campos corretamente!");

		return deferred;
	};
	
	this.saveComposicaoProduto = function (widget) {
		
		General.saveCrud(widget).then(function(){
			// widget.reload();
			
			var widgetComp = templateManager.container.getWidget('composicaoProduto');
			widgetComp.activate();
			widgetComp.reload();
		});
		
	};
	
	this.saveInsumoComposicao = function (widget) {
		
		General.saveCrud(widget).then(function(){
			// widget.reload();
			
			var widgetComp = templateManager.container.getWidget('insumosComposicao');
			widgetComp.activate();
			widgetComp.reload();
		});
		
	};
	
	this.deleteCrudCheckedRows = function (widget) {
        var deferred = ZHPromise.defer();
        ScreenService.confirmMessage(ScreenService.i18n('Delete the selected registers?'), 'question', function (success) {
            widget.removeCheckedRows().then(function () {
                widget.reload();
                widget.unSelectAll();
                deferred.resolve();
            }, function (error) {
                if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                    ScreenService.showMessage('Exclusão não permitida! O(s) registro(s) possui(em) registros filhos.');
                } else {
                    ScreenService.showMessage(error.data.error);
                }
                deferred.reject();
            });
        });
        return deferred.promise;
    };
    
    this.deleteComposicaoProduto = function (widget) {
		var deferred = ZHPromise.defer();
		ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
			widget.removeRow().then(function () {
				// ScreenService.closeSwipe().then(function () {
					widget.activate();
					deferred.resolve();
				// });
			}, function (error) {
				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
					ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
				} else {
					ScreenService.showMessage(error.data.error);
				}
				deferred.reject();
			});
		});
		return deferred.promise;
	};
    
    this.validaLinhaSelecionada = function(widget){
		var checkedRows = widget.getCheckedRows();
		
		switch (widget.name) {
		    case 'especificacaoTecnica':
		        
		        if(checkedRows.length > 1){
        			widget.getAction('excluir').isVisible = false;
        		}else if(checkedRows.length == 1){
        			widget.getAction('excluir').isVisible = true;
        		}
		        break;
		}
	};
	
	this.widgetCancelForm = function (widget) {
		if (widget.currentRow.__is_new) {
			var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
			if (indexOfCurrentRow !== -1) {
				widget.dataSource.data.pop();
			}

			widget.list();
		}
	};
	
	this.habilDesabTabWidget = function (nameWidget, status) {
		var widget = templateManager.container.getWidget(nameWidget);
		
		widget.enabled = status;
	};
	
	this.clearCurrentRow = function(nameWidget, nameWidgetHabilDesab){
		var widget = templateManager.container.getWidget(nameWidget);
		
		widget.currentRow = {};
		
		// if(nameWidgetHabilDesab == 'composicaoProduto'){
			this.habilDesabTabWidget(nameWidgetHabilDesab, false);
		// }
	};
	
	this.loadDataSourceInsumos = function(){
		var widget = templateManager.container.getWidget('insumosComposicao');
		
		// widget.reload();
	};
	
	this.activeWidget = function(widgetName){
		var widget = templateManager.container.getWidget(widgetName);
		
		widget.activate();
	};
	
	this.activeWidget = function(widgetName){
		var widget = templateManager.container.getWidget(widgetName);
		
		widget.activate();
	};
    
    /*var rowEditedInline = function(row){
        let boolEdited = false;
        
        $.each(row, function(index, value) {
            if(row.hasOwnProperty('changed_'+index)){
                boolEdited = true;
            }
        }); 

        return boolEdited;
    };*/
    
    this.validaIntervaloVigencia = function(){
		var widget = templateManager.container.getWidget('vigencia');
		
		var data = widget.dataSource.data;
		var ultimo = data[data.length - 2];
		
		if(ultimo){
			var currentRow = widget.currentRow;
			
			var dtUltimaVigencia = ultimo.DTVALFIMESPEPRO.substr(0, [10]);
			dtUltimaVigencia = new Date(dtUltimaVigencia.split('/').reverse().join('/'));
			
			var dtNovaVigencia = currentRow.DTVALESPEPRO.substr(0, [10]);
			dtNovaVigencia = new Date(dtNovaVigencia.split('/').reverse().join('/'));
			
			if (dtNovaVigencia < dtUltimaVigencia) {
			    ScreenService.showMessage("Inicio de Vigência da Especificação Técnica do Produto deve ser maior que '"+dtUltimaVigencia.getDateBr()+"'");
			}
			else {
				this.saveNewInForm(widget);
			}
		}else{
			this.saveNewInForm(widget);
		}
    	
    };

}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cdp05000_ProcessoFabricacao_Controller', Cdp05000_ProcessoFabricacao_Controller);
});

// FILE: ./assets/js/controllers/QPR00100_Plano_AmostragemController.js
function QPR00100_Plano_AmostragemController(templateManager, restEngine, General, ScreenService, ZHPromise, ZhFilterPreferences) {


    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        rowsToSet.CDFILIAL = getLocalVar("CDFILIAL");
        rowsToSet.NMFILIAL = getLocalVar("NMFILIAL");

        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };

    this.setFieldsGerais = function(widget) {
        templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
    };

    this.saveCrud = function(args) {
        var isNew = args.owner.widget.currentRow.__is_new;
        General.saveCrud(args.owner.widget).then(function(response) {
            if (!isNew) {
                General.modEdit(args.owner.widget);
                General.cancelModEdit(args);
            }
            else {
                var widgetsToActivate = args.owner.widget.widgets;

                General.changeWidgetAcessibility(
                    widgetsToActivate.filter(function(subwidget) {
                        return subwidget.name != args.owner.widget.name;
                    }).concat(args.owner.widget), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
                    true);
            }
        });
    };

    this.widgetSave = function(widget) {
        General.saveCrud(widget);
        widget.getField('QTLOTEINIAMO').readOnly = false;
        widget.getField('QTLOTEFINAMO').readOnly = false;
    };

    this.backOrCancel = function(args) {
        General.backOrCancel(args);
        args.owner.widget.getField('QTLOTEINIAMO').readOnly = false;
        args.owner.widget.getField('QTLOTEFINAMO').readOnly = false;
    };

    this.widgetEdit = function(widget) {
        General.widgetEdit(widget);
        widget.getField('QTLOTEINIAMO').readOnly = true;
        widget.getField('QTLOTEFINAMO').readOnly = true;
    };

    this.minValue = function(widget) {
        if (widget.getField('QTLOTEINIAMO').value() !== "") {
            if (parseFloat(widget.getField('QTLOTEINIAMO').value()) > parseFloat(widget.getField('QTLOTEFINAMO').value())) {
                // ScreenService.i18n("Minimum value: ") + widget.getField('QTLOTEINIAMO').value();
                widget.getField('QTLOTEFINAMO').setValue(widget.getField('QTLOTEINIAMO').value());
                widget.getField('QTLOTEFINAMO').reload();
            }
        }
    };

    this.maxValue = function(widget) {
        if (widget.getField('QTLOTEFINAMO').value() !== "") {
            if (parseFloat(widget.getField('QTLOTEINIAMO').value()) > parseFloat(widget.getField('QTLOTEFINAMO').value())) {
                // ScreenService.i18n("Maximum value: ") + widget.getField('QTLOTEFINAMO').value();
                widget.getField('QTLOTEINIAMO').setValue(widget.getField('QTLOTEFINAMO').value());
                widget.getField('QTLOTEINIAMO').reload();
            }
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('QPR00100_Plano_AmostragemController', QPR00100_Plano_AmostragemController);
});


// FILE: ./assets/js/controllers/QPR00800_Cobaia_Controller.js
function QPR00800_Cobaia_Controller(templateManager, restEngine, General, ScreenService, ZHPromise, ZhFilterPreferences) {

    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        rowsToSet.CDFILIAL = getLocalVar("CDFILIAL");
        rowsToSet.NMFILIAL = getLocalVar("NMFILIAL");

        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };

    this.setFieldsGerais = function(widget) {
        templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
    };

    this.validDTNASCCOBAIA = function(field) {

        if ((field.value()) && (field.getParent().currentRow.DTOBITCOBAIA)) {

            var anoNascimento = field.value().substring(6, 10);
            var mesNascimento = field.value().substring(3, 5);
            var diaNascimento = field.value().substring(0, 2);

            var anoObito = field.getParent().currentRow.DTOBITCOBAIA.substring(6, 10);
            var mesObito = field.getParent().currentRow.DTOBITCOBAIA.substring(3, 5);
            var diaObito = field.getParent().currentRow.DTOBITCOBAIA.substring(0, 2);

            if (anoNascimento > anoObito) {
                field.getParent().currentRow.DTOBITCOBAIA = "";
                ScreenService.showMessage('A data de Nascimento deve ser antes da data de Obito');
            }
            else if ((anoNascimento === anoObito) && (mesNascimento > mesObito)) {
                field.getParent().currentRow.DTOBITCOBAIA = "";
                ScreenService.showMessage('A data de Nascimento deve ser antes da data de Obito');
            }
            else if (((anoNascimento === anoObito) && (mesNascimento === mesObito)) && (diaNascimento > diaObito)) {
                field.getParent().currentRow.DTOBITCOBAIA = "";
                ScreenService.showMessage('A data de Nascimento deve ser antes da data de Obito');
            }
        }
    };

    this.validDTOBITCOBAIA = function(field) {

        if ((field.value()) && (field.getParent().currentRow.DTNASCCOBAIA)) {

            var anoObito = field.value().substring(6, 10);
            var mesObito = field.value().substring(3, 5);
            var diaObito = field.value().substring(0, 2);

            var anoNascimento = field.getParent().currentRow.DTNASCCOBAIA.substring(6, 10);
            var mesNascimento = field.getParent().currentRow.DTNASCCOBAIA.substring(3, 5);
            var diaNascimento = field.getParent().currentRow.DTNASCCOBAIA.substring(0, 2);

            if (anoObito < anoNascimento) {
                field.getParent().currentRow.DTNASCCOBAIA = "";
                ScreenService.showMessage('A data de Nascimento deve ser antes da data de Obito');
            }
            else if ((anoNascimento === anoObito) && (mesObito < mesNascimento)) {
                field.getParent().currentRow.DTNASCCOBAIA = "";
                ScreenService.showMessage('A data de Nascimento deve ser antes da data de Obito');
            }
            else if (((anoNascimento === anoObito) && (mesNascimento === mesObito)) && (diaObito < diaNascimento)) {
                field.getParent().currentRow.DTNASCCOBAIA = "";
                ScreenService.showMessage('A data de Nascimento deve ser antes da data de Obito');
            }
        }
    };

    this.editDados = function(widget) {

        General.edit(widget);
        widget.widgets.forEach(function(element) {
            element.enabled = false;
        });

    };

    this.cancelEdit = function(widget) {

        widget.widgets.forEach(function(element) {
            element.enabled = true;
        });
    };

    this.saveDados = function(widget) {

        General.saveCrud(widget);
        widget.widgets.forEach(function(element) {
            element.enabled = true;
        });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('QPR00800_Cobaia_Controller', QPR00800_Cobaia_Controller);
});


// FILE: ./assets/js/controllers/QPR01000_Parametros_Qualidade_Producao_Controller.js
function QPR01000_Parametros_Qualidade_Producao_Controller (QPR01000_Parametros_Qualidade_Producao_Service, templateManager, restEngine, General, ScreenService,ZHPromise){

	this.setDefaultFilial = function(widget) {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];

        General.callRestEngine('cdp#/crud/operador', 'FilterData', filter).then(function(response) {
            widget.currentRow.CDFILIAL = response.dataset.operador[0].CDFILIALSELECIONADA;
            widget.currentRow.NMFILIAL = response.dataset.operador[0].CDFILIALSELECIONADA;
            this.filtroParametrosFilial(widget.getField('NMFILIAL'));
            this.setFilial(widget.getField('NMFILIAL'));
        }.bind(this));
    };

    this.widgetEdit = function (widget) {
    	if(!Util.isEmptyOrBlank(widget.dataSource.data)){
			if (!widget.editing) {
				//Trata a edição de uma widget filha do tipo form
				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
				    
				    this.changeBarAcessibility(widget.parent, false);
					
				} else //trata a edição dos demais casos
					General.changeWidgetAcessibility(widget.widgets, false);
	
				//propriedades a serem ignoradas na criação do backup
				var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
	
				//faz backup da currentRow para permitir a recuperação dos dados
				widget.backupRow = Util.clone(widget.currentRow, ignoredKeys);
				widget.edit();
				return true;
			} else return false;
    	} else{
    		this.NewRow(widget);
    	}
	};
    
    this.backOrCancel = function (args) {
		
		General.formWidgetSwitchTemplate(args.owner.widget);
		
		this.changeBarAcessibility(args.owner.widget.parent ,true);
		
		if (args.row.__is_new) {
			args.owner.widget.list(true);
			args.owner.widget.dataSource.data.pop();
			args.owner.widget.currentRow = {};
		} else if (args.owner.widget.mode === 'edit') {
			args.owner.widget.list();
			for (var i in args.owner.widget.backupRow) {
				args.owner.widget.currentRow[i] = args.owner.widget.backupRow[i];
			}
		}
		ScreenService.goBack();
	};
	
	this.filtroParametrosFilial =  function(field){
    	var filial = field.getParent().fields[1].value();
    	var allTabbeds =field.getParent().getParent().widgets; 
       	allTabbeds.forEach(function(widget){
       		this.activateAction(widget, !filial);
       	}.bind(this));
    };
    
    this.activateAction = function(widget, state){
    	widget.widgets.forEach(function(widget){
    		widget.actions.forEach(function(action){
    			action.readOnly = state;
    		});
    	});
    };
    
    this.recarregarField = function(nomeWidget,nomeField){
        var field =  templateManager.container.getWidget(nomeWidget).getField(nomeField);
        field.reload();
    };
    
    this.WidgetOnEnter = function(args){
        args.owner.currentRow = args.owner.dataSource.data[0];
    };
    
    this.changeBarAcessibility = function(widget, status){
        var widgetsToChange = widget.parent.widgets;

		General.changeWidgetAcessibility(
			widgetsToChange.filter(function (subwidget) {
				return subwidget.name != widget.name;
			}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
		status);
    };
    
    this.changeLocalEstoqAcessibility = function (grid){
        var gridParametrosControleQualidade =  templateManager.container.getWidget(grid);
        if (gridParametrosControleQualidade.currentRow === undefined){
        	gridParametrosControleQualidade.currentRow = {};
        }
        var almoxarifado = gridParametrosControleQualidade.getField('CDALMOXARIFE').value();
        if(almoxarifado){
            gridParametrosControleQualidade.getField('DSLOCALESTOQ').readOnly = false;
        }else{
            gridParametrosControleQualidade.getField('DSLOCALESTOQ').readOnly = true;}
            gridParametrosControleQualidade.getField('DSLOCALESTOQ').reload();
    };
    
    
    this.getProxConsulta = function (args){
    
    QPR01000_Parametros_Qualidade_Producao_Service.findProxConsulta(args.owner).then(function(success) {
        var gridReanalise = templateManager.container.getWidget('grid_reanalise');
        if(success.dataset.parametroqpr_param_qualidade_prox_consulta[0] || (success.dataset.parametroqpr_param_qualidade_prox_consulta[1])){
            if(success.dataset.parametroqpr_param_qualidade_prox_consulta[0]){
	            gridReanalise.getField('DTHRPROXIMACONSULTA').setValue(success.dataset.parametroqpr_param_qualidade_prox_consulta[0].DTHRPROXIMACONSULTA);
            }
            if(success.dataset.parametroqpr_param_qualidade_prox_consulta[1]){
            	gridReanalise.getField('DTHRULTIMACONSULTA').setValue(success.dataset.parametroqpr_param_qualidade_prox_consulta[1].DTULTCONSULTA);
            }
            gridReanalise.getField('SITUACAOCONSUL').setValue('ATIVO');
        } else {
            gridReanalise.getField('SITUACAOCONSUL').setValue('INATIVO');
        }
        
    });  
    };
    
    this.widgetSave = function (widget, afterValid) {
		
		var deferred = ZHPromise.defer();

		if (widget.isValid()) {
			widget.currentRow.changed = true;

			if (!widget.currentRow.__is_new)
				widget.currentRow.__is_new = false;
			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
			}

			widget.saveRow().then(function (response) {
				widget.currentRow.changed = false;
				delete widget.backupRow;

				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
					widget.list();

					var widgets = widget.parent.widgets;
					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
					this.changeBarAcessibility(widget.parent ,true);
				} else {
					if (widget.currentRow.__is_new) {
						ScreenService.closeSwipe();
						widget.list();
					} else widget.list();

					General.changeWidgetAcessibility(widget.widgets, true);
				}

				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
				else widget.reload();

				deferred.resolve(response);
			}.bind(this), function (error) {
				var errorMessage = 'Timeout';

				if (error.data) errorMessage = error.data.error;

				ScreenService.showMessage(errorMessage);
				deferred.reject(errorMessage);
			});
		} else deferred.reject("Preencha todos os campos corretamente!");

		return deferred;	
	};
	
	this.setFilial = function(field){
		var gridMain = templateManager.container.getWidget('tabbed_main');
            gridMain.widgets[0].getField('CDFILIAL').setValue(field.getParent().fields[1].value());
            gridMain.widgets[0].getField('NMFILIAL').setValue(field.value());
            gridMain.widgets[1].getField('CDFILIAL').setValue(field.getParent().fields[1].value());
            gridMain.widgets[1].getField('NMFILIAL').setValue(field.value());
            gridMain.widgets[2].getField('CDFILIAL').setValue(field.getParent().fields[1].value());
            gridMain.widgets[2].getField('NMFILIAL').setValue(field.value());
            gridMain.widgets[0].widgets[0].reload();
            gridMain.widgets[1].widgets[0].reload();
            gridMain.widgets[2].widgets[0].reload();
	};
	
	this.NewRow = function(widget){
		this.changeBarAcessibility(widget.parent, false);
		General.formWidgetSwitchTemplate(widget);
		templateManager.container.getWidget(widget.name).setCurrentRow({});
		widget.newRow();
		widget.currentRow.CDFILIAL = widget.parent.fields[1].value();
	};
	
	this.setFieldsOnAutorizacaoReadOnly = function(widget, state){
		widget.getField('IDAUTGRUPOP').readOnly = state;
		widget.getField('DSGRUPOPER').readOnly = state;
	};
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('QPR01000_Parametros_Qualidade_Producao_Controller', QPR01000_Parametros_Qualidade_Producao_Controller);
});

// FILE: ./assets/js/controllers/QPR01800_Itens_Checagem_Controller.js
function QPR01800_Itens_Checagem_Controller(templateManager, restEngine, General, ScreenService, ZhFilterPreferences) {

    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        rowsToSet.CDFILIAL = getLocalVar("CDFILIAL");
        rowsToSet.NMFILIAL = getLocalVar("NMFILIAL");

        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };

    this.setFieldsGerais = function(widget) {
        templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
    };

    this.filtraItensQuestao = function(args) {

        var widgetItemChecagem = args.owner;
        var widgetItemQuestao = templateManager.container.getWidget('itensQuestao');
        widgetItemQuestao.currentRow.CDCHECKLIST = [{

            "name": "CDCHECKLIST",
            "operator": "=",
            "value": widgetItemChecagem.getField('CDCHECKLIST').value()

        }];
    };

    this.setDataSourceFilter = function(widget) {
        widget.currentRow.CDCHECKLIST = widget.getParent().currentRow.CDCHECKLIST;
        widget.dataSourceFilter = [{
            name: "CDCHECKLIST",
            operator: "=",
            value: widget.getParent().currentRow.CDCHECKLIST
        }];
        widget.reload();
    };

    this.setViewResp = function(widget) {
        // widget.currentRow.TPQUESTCHECK;
        switch (widget.currentRow.TPQUESTCHECK) {
            case 'BOO':
                widget.widgets[0].isVisible = true;
                widget.widgets[1].isVisible = false;
                widget.widgets[2].isVisible = false;
                break;
            case 'CAD':
                widget.widgets[0].isVisible = false;
                widget.widgets[1].isVisible = true;
                widget.widgets[2].isVisible = false;
                break;
            case 'VAL':
                widget.widgets[0].isVisible = false;
                widget.widgets[1].isVisible = false;
                widget.widgets[2].isVisible = true;
                break;
            default:
                widget.widgets[0].isVisible = false;
                widget.widgets[1].isVisible = false;
                widget.widgets[2].isVisible = false;
        }

        widget.reload();
    };

    this.setTelaResp = function(widget) {
        widget.currentRow.CDCHECKLIST = widget.getParent().currentRow.CDCHECKLIST;
        widget.currentRow.NRQUESTCHECK = widget.getParent().currentRow.NRQUESTCHECK;
        widget.dataSourceFilter = [{
                name: "CDCHECKLIST",
                operator: "=",
                value: widget.getParent().currentRow.CDCHECKLIST
            },
            {
                name: "NRQUESTCHECK",
                operator: "=",
                value: widget.getParent().currentRow.NRQUESTCHECK
            }
        ];
        widget.reload();
    };

    this.saveQuestao = function(widget) {
        widget.currentRow.CDCHECKLIST = widget.parent.currentRow.CDCHECKLIST;
        General.saveCrud(widget).then(function(success) {
            widget.reload();
            this.setViewResp(widget);
        }.bind(this));
    };

    this.deleteChecagem = function(widget) {
        ScreenService.showCustomDialog('Deseja Excluir o Item?', 'question', 'question', [{
            label: ScreenService.i18n("Sim"),
            code: function() {
                restEngine.post("cdp_qualidade#/ItemChecagem/remove", { 'requestType': 'DataSet', 'dataset': [widget.currentRow] })
                    .then(function(data) {
                        widget.reload();
                        ScreenService.showMessage('Item excluido com sucesso!!');
                        ScreenService.closeSwipe();
                        widget.reload();
                    }).
                catch(function(e) {
                    ScreenService.showMessage(e.data.error);
                    ScreenService.closeSwipe();
                });
            }.bind(this)
        }, {
            label: ScreenService.i18n("Não"),
            code: function() {}.bind(this)
        }]);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('QPR01800_Itens_Checagem_Controller', QPR01800_Itens_Checagem_Controller);
});


// FILE: ./assets/js/controllers/QPR01900_Inspecao_Digital_Controller.js
function QPR01900_Inspecao_Digital_Controller (localStorageEngine, templateManager, restEngine, General, ScreenService, QPR01900_Inspecao_Digital_Service){
    
    var cdChecklist;
    var nrOrdProd;
    var nrSubOrdProd;
    
    var mensagens = [];
    mensagens.filtroIncompleto = "É necessário preencher todos os campos do Filtro.";
    
    var currentQuest;
    var currentQuestPosDataSource;
    var currentQuestPosInterface;
    var currentCadQuest;
    var currentCadQuestNewCode;
    var originalRow;
    var cadRowsToDelete = [];
    
    this.openFilter = function(args) {
        ScreenService.openPopup(templateManager.container.getWidget('TarefaFilter'));
        templateManager.container.getWidget('TarefaFilter').isVisible = true;
    };
    
    this.checkFilter = function(args) {
        var row = args.owner.field.widget.currentRow;
        
        args.owner.field.widget.getField('LANCAMENTOFIN').setValue(null);
        args.owner.field.widget.getField('LANCAMENTOFIN').readOnly = !row.LANCAMENTOINI;
        if (row.LANCAMENTOINI) {
            args.owner.field.widget.getField('LANCAMENTOFIN').minDate = args.owner.field.widget.getField('LANCAMENTOINI').value();
        }
    };
    
    this.retornaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("ger#/crud/operador", filter);
    };    
        
    this.getLocalData = function() {
        var mainWidget = templateManager.container.getWidget('inspecao_digital');
        var filterWidget = templateManager.container.getWidget('TarefaFilter');
        
        if (filterWidget.currentRow.LANCAMENTOINI && filterWidget.currentRow.LANCAMENTOFIN) {
            var minDate = filterWidget.currentRow.LANCAMENTOINI;
            var maxDate = filterWidget.currentRow.LANCAMENTOFIN;
            var params = [];
            
            this.retornaOperadorLogado().then(function(callback){
                params.push(callback[0].CDOPERADOR);
                params.push(minDate);
                params.push(maxDate);
                QPR01900_Inspecao_Digital_Service.searchTarefaQuestao(params).then(function(success){
                    
                    localStorageEngine.setDataSource('inspecaoTarefa', success.dataset.resultados.tarefa);
                    localStorageEngine.setDataSource('inspecaoQuestao', success.dataset.resultados.questao);
                    localStorageEngine.setDataSource('respostaVal', success.dataset.resultados.respostaVal);
                    localStorageEngine.setDataSource('respostaBool', success.dataset.resultados.respostaBool);
                    localStorageEngine.setDataSource('respostaCad', success.dataset.resultados.respostaCad);
                    localStorageEngine.setDataSource('respQuestVisBoo', success.dataset.resultados.respQuestVisBoo);
                    localStorageEngine.setDataSource('respQuestVar', success.dataset.resultados.respQuestVar);
                    localStorageEngine.setDataSource('respQuestCad', success.dataset.resultados.respQuestCad);
                    
                    localStorageEngine.getDataSource('inspecaoTarefa', []).then(function(inspecaoTarefa) {
                        mainWidget.dataSource.data = inspecaoTarefa;
                        ScreenService.closePopup();
                        ScreenService.closePopup();
                    });
                }.bind(this));
            });
        } else {
            ScreenService.showMessage(mensagens.filtroIncompleto);
        }
    };
    
    this.questionApplyFilter = function(widget) {
        
        var filter = [{
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": cdChecklist
        }, {
            "name": "NRORDPROD",
            "operator": "=",
            "value": nrOrdProd
        }, {
            "name": "NRSUBORDPROD",
            "operator": "=",
            "value": nrSubOrdProd
        }];
        
        localStorageEngine.getDataSource('inspecaoQuestao', filter).then(function(inspecaoQuestao) {
            templateManager.container.getWidget('WidgetQuestoes').dataSource.data = inspecaoQuestao;
         });
    }.bind(this);
    
    this.openRespWidget = function(widget) {
        localStorageEngine.getDataSource('inspecaoQuestao').then(function(inspecaoQuestao) {
            var found = false;
            for(var i=0; i<inspecaoQuestao.length && found==false; i++) {
                if (inspecaoQuestao[i].NRQUESTCHECK == widget.currentRow.NRQUESTCHECK && inspecaoQuestao[i].CDCHECKLIST == widget.currentRow.CDCHECKLIST && inspecaoQuestao[i].NRORDPROD == widget.currentRow.NRORDPROD && inspecaoQuestao[i].NRSUBORDPROD == widget.currentRow.NRSUBORDPROD) {
                    for(var j=0; j<widget.dataSource.data.length && found==false; j++) {
                    	if (widget.dataSource.data[j] == widget.currentRow) {
                    	    found = true;
                	        this.currentQuest = inspecaoQuestao[i];
                	        this.currentQuestPosDataSource = i;
                	        this.currentQuestPosInterface = j;
                            if (widget.currentRow.TPQUESTCHECK == 'BOO') {
                                this.openBoolResp();
                            }
                            if (widget.currentRow.TPQUESTCHECK == 'VAL') {
                                this.openValResp();
                            }
                            if (widget.currentRow.TPQUESTCHECK == 'VIS') {
                                this.openVisResp();
                            }
                            if (widget.currentRow.TPQUESTCHECK == 'CAD') {
                                this.openCadResp();
                            }
                        }
                    }
                }
            }
        }.bind(this));
    };
    
    this.openVisResp = function() {
        var filter = [{
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": cdChecklist
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }];
       localStorageEngine.getDataSource('respostaBool', filter).then(function(respostaBool) {
           localStorageEngine.getDataSource('respQuestVisBoo').then(function(respQuestVisBoo) {
               localStorageEngine.getDataSource('inspecaoQuestao').then(function(inspecaoQuestao) {
        		if (this.currentQuest.IDSITQUESTAROP == 3) {
        		    this.currentQuest.IDSITQUESTAROP = 1;
        		} else {
        		    this.currentQuest.IDSITQUESTAROP = 3;
        		}
        		
        		var found = false;
        		for (var i=0; i<respQuestVisBoo.length && found == false; i++) {
        		    if (respQuestVisBoo[i].NRORDPROD == this.currentQuest.NRORDPROD && respQuestVisBoo[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
        		        found = true;
        		        if (this.currentQuest.IDSITQUESTAROP == 1) {
        		            respQuestVisBoo[i].IDRESPVISTO = 'NOK';   
        		        } else respQuestVisBoo[i].IDRESPVISTO = 'SOK';    
        		    }
        		}
        		if (found == false) {
        		    respQuestVisBoo.push(this.makeVisBooResp('Vis', this.currentQuest.IDSITQUESTAROP));
        		}
        		
                inspecaoQuestao[this.currentQuestPosDataSource] = this.currentQuest;
                localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                localStorageEngine.setDataSource('respQuestVisBoo', respQuestVisBoo);
        	    templateManager.container.getWidget('WidgetQuestoes').dataSource.data[this.currentQuestPosInterface].IDSITQUESTAROP = inspecaoQuestao[this.currentQuestPosDataSource].IDSITQUESTAROP;
        		
    		    if (respostaBool[0].DSRESPVISTO) {
    		        ScreenService.showMessage(respostaBool[0].DSRESPVISTO);
    		    }
                this.colorizeQuestion();
               }.bind(this));
           }.bind(this));
       }.bind(this));
    
    };
    
    this.openBoolResp = function() {
        var boolRespWidget = templateManager.container.getWidget('WidgetBoolResp');
        localStorageEngine.getDataSource('respostaBool').then(function(respostaBool) {
            var found = false;
            ScreenService.openPopup(boolRespWidget);
            
            for (var i=0; i<respostaBool.length && found == false; i++) {
                if (respostaBool[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                    found = true;
                    boolRespWidget.fields[0].dataSource.data[0].NMRESPBOOL = respostaBool[i].DSRESPFALSO;
                    boolRespWidget.fields[0].dataSource.data[1].NMRESPBOOL = respostaBool[i].DSRESPVERD;
                }
            }
        }.bind(this));
    };
    
    this.openValResp = function() {
        var valRespWidget = templateManager.container.getWidget('WidgetValResp');
        ScreenService.openPopup(valRespWidget);
    };
    
    this.confirmBoolResp = function(widget) {
        var Value = widget.currentRow.IDRESPBOOL;
        
        var filter = [{
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": cdChecklist
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }];
        
        localStorageEngine.getDataSource('respostaBool', filter).then(function(respostaBool) {
            localStorageEngine.getDataSource('respQuestVisBoo').then(function(respQuestVisBoo) {
                if (respostaBool) {
                    localStorageEngine.getDataSource('inspecaoQuestao').then(function(inspecaoQuestao) {
                        if (Value == 'F') {
                            this.currentQuest.IDSITQUESTAROP = '2';
                            inspecaoQuestao[this.currentQuestPosDataSource] = this.currentQuest;
                            localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                        } else if (Value == 'V') {
                            this.currentQuest.IDSITQUESTAROP = '3';
                            inspecaoQuestao[this.currentQuestPosDataSource] = Util.clone(this.currentQuest);
                            localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                        }
                        
                        var found = false;
                		for (var i=0; i<respQuestVisBoo.length && found == false; i++) {
                		    if (respQuestVisBoo[i].NRORDPROD == this.currentQuest.NRORDPROD && respQuestVisBoo[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                		        found = true;
                		        if (this.currentQuest.IDSITQUESTAROP == 2) {
                		            respQuestVisBoo[i].IDVERDFALSO = 'N';   
                		        } else if (this.currentQuest.IDSITQUESTAROP == 3) respQuestVisBoo[i].IDVERDFALSO = 'S';    
                		    }
                		}
                		if (found == false) {
                		    respQuestVisBoo.push(this.makeVisBooResp('Bool', this.currentQuest.IDSITQUESTAROP));
                		}
                        
                        localStorageEngine.setDataSource('respQuestVisBoo', respQuestVisBoo);
                        templateManager.container.getWidget('WidgetQuestoes').dataSource.data[this.currentQuestPosInterface].IDSITQUESTAROP = inspecaoQuestao[this.currentQuestPosDataSource].IDSITQUESTAROP;
                        ScreenService.closePopup();
                        this.colorizeQuestion();
                    }.bind(this));
                } else {
                    ScreenService.showMessage('Não existe este tipo de resposta.');
                }
                this.colorizeQuestion(); 
            }.bind(this));
         }.bind(this));
    };
    
    this.confirmValResp = function(widget) {
        var Value = widget.currentRow.RESPVAL;
        
        var filter = [{
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": cdChecklist
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }];
        
        localStorageEngine.getDataSource('respostaVal', filter).then(function(respostaVal) {
            
            var found = false;
            var response;
            var responseValue;
            
            for(var i=0; i<respostaVal.length && found==false; i++) {
                if (respostaVal[i].TPFXVR == '<') {
                    if (Value < respostaVal[i].FXINICIAL) {
                        found = true;
                    }
                } else if (respostaVal[i].TPFXVR == '>') {
                    if (Value > respostaVal[i].FXINICIAL) {
                        found = true;
                    }
                } else if (respostaVal[i].TPFXVR == 'E') {
                    if (Value >= respostaVal[i].FXINICIAL && Value <= respostaVal[i].FXFINAL) {
                        found = true;
                    }
                }
                if (found) {
                    response = respostaVal[i].DSRESPVR;
                    responseValue = respostaVal[i].PONTVRCHECK;
                }
            }
            
            if (found) {
                ScreenService.showMessage(response);
                localStorageEngine.getDataSource('inspecaoQuestao').then(function(inspecaoQuestao) {
                    localStorageEngine.getDataSource('respQuestVar').then(function(respQuestVar) {
                        if (responseValue == 'I') {
                            this.currentQuest.IDSITQUESTAROP = '2';
                            inspecaoQuestao[this.currentQuestPosDataSource] = this.currentQuest;
                            localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                        } else if (responseValue == 'C' || responseValue == 'A') {
                            this.currentQuest.IDSITQUESTAROP = '3';
                            inspecaoQuestao[this.currentQuestPosDataSource] = Util.clone(this.currentQuest);
                            localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                        }
                        
                        var found = false;
                		for (var i=0; i<respQuestVar.length && found == false; i++) {
                		    if (respQuestVar[i].NRORDPROD == this.currentQuest.NRORDPROD && respQuestVar[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                		        found = true;
                		        respQuestVar[i].VRRESPTAR = Value;   
                		    }
                		}
                		if (found == false) {
                		    respQuestVar.push(this.makeVarResp(Value));
                		}
                        
                        localStorageEngine.setDataSource('respQuestVar', respQuestVar);
                        templateManager.container.getWidget('WidgetQuestoes').dataSource.data[this.currentQuestPosInterface].IDSITQUESTAROP = inspecaoQuestao[this.currentQuestPosDataSource].IDSITQUESTAROP;
                        ScreenService.closePopup();
                        this.colorizeQuestion();
                    }.bind(this));
                }.bind(this));
            } else {
                ScreenService.showMessage('Não existe este tipo de resposta.');
            }
            this.colorizeQuestion();
         }.bind(this));
    };
    
    this.colorizeQuestion = function() {
        var list = document.querySelector('body > span > section > section > div.default-window.ng-scope > section.zh-swipe-container.zh-swipe-right.ng-scope.open > div > div:nth-child(3) > section > section > div > section > div > div.container.zh-list-container.ng-scope.ng-isolate-scope.nonbounce > ul');
        list = list.querySelectorAll('li.zh-list-item-label');

        if (this.currentQuest.IDSITQUESTAROP == '3'){
            list[this.currentQuestPosInterface].childNodes[7].querySelectorAll('div.row')[1].style.color = 'green';   
        } else if (this.currentQuest.IDSITQUESTAROP == '2'){
            list[this.currentQuestPosInterface].childNodes[7].querySelectorAll('div.row')[1].style.color = 'red';   
        } else if (this.currentQuest.IDSITQUESTAROP == '1'){
            list[this.currentQuestPosInterface].childNodes[7].querySelectorAll('div.row')[1].style.color = 'black';   
        } 
    };
    
    this.colorizeAllQuestions = function() {
        var list = document.querySelector('body > span > section > section > div.default-window.ng-scope > section.zh-swipe-container.zh-swipe-right.ng-scope.open > div > div:nth-child(3) > section > section > div > section > div > div.container.zh-list-container.ng-scope.ng-isolate-scope.nonbounce > ul');
        list = list.querySelectorAll('li.zh-list-item-label');
        
        for(var i=0; i<list.length; i++) {
            var span = list[i].childNodes[7].querySelectorAll('div.row')[1].childNodes[1].childNodes[3].innerHTML;
            
            if (span == 'Pendente.') {
                list[i].childNodes[7].querySelectorAll('div.row')[1].style.color = 'black';   
            } else if (span == 'Correta.') {
                list[i].childNodes[7].querySelectorAll('div.row')[1].style.color = 'green';
            } else if (span == 'Incorreta.') {
                list[i].childNodes[7].querySelectorAll('div.row')[1].style.color = 'red';
            }
        }
        
    };
    
    this.openCadResp = function() {
        var cadHolderRespWidget = templateManager.container.getWidget('WidgetCadRespHolder');
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var CadRespView =   templateManager.container.getWidget('WidgetCadRespView');
        localStorageEngine.getDataSource('respQuestCad').then(function(respQuestCad) {
            var currentResp = [];
            for (var i=0; i<respQuestCad.length; i++) {
                if (respQuestCad[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                    currentResp.push(respQuestCad[i]);
                }
            }
            
            for (i=0; i<cadRespWidget.actions.length; i++) {
                cadRespWidget.actions[i].isVisible = true;
            }
            
            cadRespWidget.dataSource.data = currentResp;
            
            localStorageEngine.getDataSource('respostaCad').then(function(respostaCad) {
                var found = false;
                for (var i=0; i<respostaCad.length && found == false; i++) {
                    if (respostaCad[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                        found = true;
                        
                        this.currentCadQuest = respostaCad[i];
                        
                        if(respostaCad[i].IDPRODUTO == 'S') {
                            cadRespWidget.fields[1].isVisible = true;
                            CadRespView.fields[0].isVisible = true;
                            if(respostaCad[i].IDLOTE == 'S') {
                                cadRespWidget.fields[3].readOnly = true;
                                CadRespView.fields[2].readOnly = true;
                            }
                        }
                        if(respostaCad[i].IDEQUIPA == 'S') {
                            cadRespWidget.fields[2].isVisible = true;
                            CadRespView.fields[1].isVisible = true;
                        }
                        if(respostaCad[i].IDLOTE == 'S') {
                            cadRespWidget.fields[3].isVisible = true;
                            CadRespView.fields[2].isVisible = true;
                        }
                        if(respostaCad[i].IDOPERADOR == 'S') {
                            cadRespWidget.fields[4].isVisible = true;
                            CadRespView.fields[3].isVisible = true;
                        }
                        
                        if(respostaCad[i].DSCOLUNA1) {
                            CadRespView.fields[4].isVisible = true;
                            CadRespView.fields[4].label = respostaCad[i].DSCOLUNA1;
                        }
                        if(respostaCad[i].DSCOLUNA2) {
                            CadRespView.fields[5].isVisible = true;
                            CadRespView.fields[5].label = respostaCad[i].DSCOLUNA2;
                        }
                        if(respostaCad[i].DSCOLUNA3) {
                            CadRespView.fields[6].isVisible = true;
                            CadRespView.fields[6].label = respostaCad[i].DSCOLUNA3;
                        }
                        if(respostaCad[i].DSCOLUNA4) {
                            CadRespView.fields[7].isVisible = true;
                            CadRespView.fields[7].label = respostaCad[i].DSCOLUNA4;
                        }
                        if(respostaCad[i].DSCOLUNA5) {
                            CadRespView.fields[8].isVisible = true;
                            CadRespView.fields[8].label = respostaCad[i].DSCOLUNA5;
                        }
                        if(respostaCad[i].DSCOLUNA6) {
                            CadRespView.fields[9].isVisible = true;
                            CadRespView.fields[9].label = respostaCad[i].DSCOLUNA6;
                        }
                        if(respostaCad[i].DSCOLUNA7) {
                            CadRespView.fields[10].isVisible = true;
                            CadRespView.fields[10].label = respostaCad[i].DSCOLUNA7;
                        }
                        if(respostaCad[i].DSCOLUNA8) {
                            CadRespView.fields[11].isVisible = true;
                            CadRespView.fields[11].label = respostaCad[i].DSCOLUNA8;
                        }
                        if(respostaCad[i].DSCOLUNA9) {
                            CadRespView.fields[12].isVisible = true;
                            CadRespView.fields[12].label = respostaCad[i].DSCOLUNA9;
                        }
                        
                        ScreenService.openSwipe(cadHolderRespWidget);
                    }
                }
            }.bind(this));
        }.bind(this));
    };
    
    this.openCadRespView = function(widget) {
        var CadRespView = templateManager.container.getWidget('WidgetCadRespView');
        
        if (CadRespView.actions[0].isVisible == false) {
           for (var i=0; i<3; i++) {
               CadRespView.actions[i].isVisible = true;
           }
            
            CadRespView.currentRow = widget.currentRow;
            ScreenService.openSwipe(CadRespView);
            CadRespView.list();
        }
    };
        
    
    this.returnCadResp = function() {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var questWidget = templateManager.container.getWidget('WidgetQuestoes');
        ScreenService.closeSwipe();
        
        cadRespViewWidget.fields.forEach(function(item){ 
            item.isVisible = false;
        });
        
        cadRespWidget.fields.forEach(function(item){ 
            item.isVisible = false;
        });
        
        cadRespWidget.actions.forEach(function(item){ 
            item.isVisible = false;
        });
        
        questWidget.actions.forEach(function(item){ 
            item.isVisible = true;
        });
        
        questWidget.activate();
    };
    
    this.returnCadRespView = function() {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        
        cadRespViewWidget.actions.forEach(function(item){ 
            item.isVisible = false;
        });
        this.currentCadQuestNewCode = null;
        ScreenService.closeSwipe();
        cadRespWidget.activate();
    };
    
    this.checkQueStstate = function() {
        var questWidget = templateManager.container.getWidget('WidgetQuestoes');
        var filter = [{
            "name": "NRORDPROD",
            "operator": "=",
            "value": nrOrdProd
        }];
        
        localStorageEngine.getDataSource('inspecaoQuestao', filter).then(function(inspecaoQuestao) {
            localStorageEngine.getDataSource('respQuestCad', filter).then(function(respQuestCad) {
                for(var i=0; i<inspecaoQuestao.length; i++) {
                    if (inspecaoQuestao[i].TPQUESTCHECK == 'CAD') {
                        var found = false;
                        for(var j=0; j<respQuestCad.length && found == false; j++) {
                            if (respQuestCad[j].NRQUESTCHECK == inspecaoQuestao[i].NRQUESTCHECK) {
                                found = true;
                                inspecaoQuestao[i].IDSITQUESTAROP = 3;
                            }
                        }
                        if (found == false) {
                            inspecaoQuestao[i].IDSITQUESTAROP = 1;
                        }
                    }
                }
                localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                templateManager.container.getWidget('WidgetQuestoes').dataSource.data = inspecaoQuestao;
            }.bind(this));    
        }.bind(this));
    };
    
    this.openWidgetCadNew = function() {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        
        cadRespViewWidget.actions[4].isVisible = true;
        cadRespViewWidget.actions[6].isVisible = true;
        
        cadRespViewWidget.currentRow = [];
        cadRespViewWidget.currentRow.__is_new = true;
        ScreenService.openSwipe(cadRespViewWidget);
        cadRespViewWidget.edit();
    };
    
    this.lockLote = function(args) {
        var row = args.owner.field.widget.currentRow;
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        
        if(this.currentCadQuest.IDLOTE == 'S') {
            if (args.owner.field.widget.getField('NMPRODUTO')) {
                var filter = {
                    "name": "CDPRODUTO",
                    "operator": "=",
                    "value": args.owner.field.widget.currentRow.CDPRODUTO
                };
                
                cadRespViewWidget.fields[2].dataSourceFilter[1] = filter;
            }
            
            cadRespViewWidget.fields[2].readOnly = !row.NMPRODUTO;
            cadRespViewWidget.fields[2].clearValue();
        }
    };
    
    this.editCadResp = function(widget) {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        widget.edit();
        cadRespViewWidget.currentRow.__is_new = false;
        this.originalRow = Util.clone(widget.currentRow);
        
        if (cadRespViewWidget.currentRow.NMPRODUTO && cadRespViewWidget.currentRow.NRLOTEESTQ) {
            cadRespViewWidget.fields[2].readOnly = true;
        } else {
            cadRespViewWidget.fields[2].readOnly = false;
        }
        
        cadRespViewWidget.actions[3].isVisible = true;
        cadRespViewWidget.actions[5].isVisible = true;
    };
  
    this.cancelCadRespEdit = function(widget) {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        if (widget.currentRow.__is_new) {
          widget.dataSource.data.pop();
          widget.reload();
        } else { 
          Util.extend(widget.currentRow, this.originalRow);
        }
        
        cadRespViewWidget.actions[3].isVisible = false;
        cadRespViewWidget.actions[5].isVisible = false;
        widget.list();
    };
    
    this.saveCadRespEdit = function(widget) {
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        var filter = [{
            "name": "CDRESPCAD",
            "operator": "=",
            "value": widget.currentRow.CDRESPCAD
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }, {
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": this.currentQuest.CDCHECKLIST
        }, {
            "name": "NRORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRORDPROD
        }, {
            "name": "NRSUBORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRSUBORDPROD
        }];
        
        if (this.currentCadQuestNewCode != null) {
            filter[0] = {
                "name": "CDRESPCAD",
                "operator": "=",
                "value": this.currentCadQuestNewCode
            };
        }
        
        localStorageEngine.getDataSource('respQuestCad', filter).then(function(respQuestCad) {
            localStorageEngine.getDataSource('respQuestCad').then(function(respQuestCadAll) {
                var found = false;
                var currentResp = [];
                for (var i=0; i<respQuestCadAll.length && found==false; i++) {
                    if (this.currentCadQuestNewCode != null) {
                        if (respQuestCadAll[i].CDRESPCAD == this.currentCadQuestNewCode && respQuestCadAll[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                            found = true;
                            respQuestCadAll[i] = this.makeCadResp(widget, this.currentCadQuestNewCode);
                            localStorageEngine.setDataSource('respQuestCad', respQuestCadAll);
                        }
                    } else { 
                        if (respQuestCadAll[i].CDRESPCAD == widget.currentRow.CDRESPCAD && respQuestCadAll[i].NRQUESTCHECK == widget.currentRow.NRQUESTCHECK) {
                            found = true;
                            respQuestCadAll[i] = widget.currentRow;
                            localStorageEngine.setDataSource('respQuestCad', respQuestCadAll);
                        }
                    }
                }
                widget.reload();
                for (i=0; i<respQuestCadAll.length; i++) {
                    if (respQuestCadAll[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                        currentResp.push(respQuestCadAll[i]);
                    }
                }
                cadRespWidget.dataSource.data = currentResp;
                widget.list();
                
                cadRespViewWidget.actions[3].isVisible = false;
                cadRespViewWidget.actions[5].isVisible = false;
            }.bind(this));
        }.bind(this));
        
    };
    
    this.saveNewCadResp = function(widget) {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var filter = [{
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }, {
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": this.currentQuest.CDCHECKLIST
        }, {
            "name": "NRORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRORDPROD
        }, {
            "name": "NRSUBORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRSUBORDPROD
        }];
        
        localStorageEngine.getDataSource('respQuestCad', filter).then(function(respQuestCad) {
            localStorageEngine.getDataSource('respQuestCad').then(function(respQuestCadAll) {
                var currentResp = [];
                
                var maxCode = 0;
                for(var i=0; i<respQuestCad.length; i++) {
                    if (maxCode < parseInt(respQuestCad[i].CDRESPCAD)) {
                        maxCode = parseInt(respQuestCad[i].CDRESPCAD);
                    }
                }
                
                var newResp = this.makeCadResp(widget, this.zeroFill(maxCode+1));
                respQuestCadAll.push(newResp);
                localStorageEngine.setDataSource('respQuestCad', respQuestCadAll);
                
                for (i=0; i<respQuestCadAll.length; i++) {
                    if (respQuestCadAll[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                        currentResp.push(respQuestCadAll[i]);
                    }
                }
                cadRespWidget.dataSource.data = currentResp;
                cadRespWidget.reload();
                
                cadRespViewWidget.actions.forEach(function(item){ 
                    item.isVisible = false;
                });
                this.currentCadQuestNewCode = newResp.CDRESPCAD;
                this.openCadRespView(widget);
                this.checkQueStstate();
            }.bind(this));
        }.bind(this));
    };
    
    this.removeCadResp = function(widget) {
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var filter = [{
            "name": "CDRESPCAD",
            "operator": "=",
            "value": widget.currentRow.CDRESPCAD
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": widget.currentRow.NRQUESTCHECK
        }, {
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": this.currentQuest.CDCHECKLIST
        }, {
            "name": "NRORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRORDPROD
        }, {
            "name": "NRSUBORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRSUBORDPROD
        }];
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            localStorageEngine.getDataSource('respQuestCad').then(function(respQuestCadAll) {
                var found = false;
                var currentResp = [];
                for (var i=0; i<respQuestCadAll.length && found==false; i++) {
                    if (respQuestCadAll[i].CDRESPCAD == widget.currentRow.CDRESPCAD && respQuestCadAll[i].NRQUESTCHECK == widget.currentRow.NRQUESTCHECK) {
                        found = true;
                        cadRowsToDelete.push(respQuestCadAll[i]);
                        respQuestCadAll.splice(i, 1);
                        localStorageEngine.setDataSource('respQuestCad', respQuestCadAll);
                    }
                }
                widget.reload();
                for (i=0; i<respQuestCadAll.length; i++) {
                    if (respQuestCadAll[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                        currentResp.push(respQuestCadAll[i]);
                    }
                }
                cadRespWidget.dataSource.data = currentResp;
                cadRespWidget.reload();
                ScreenService.closeSwipe();
                this.checkQueStstate();
            }.bind(this));
		}.bind(this));
    };
    
    //função responsável por colocar "0" atrás do número
    this.zeroFill = function(number) {
    	if (number<10) {
    		return "00" + number;
        } else if (number<100) {
            return "0" + number;
        } return number;
    };
    
    this.getFilterData = function(widget) {
       cdChecklist =  widget.currentRow.CDCHECKLIST;
       nrOrdProd = widget.currentRow.NRORDPROD;
       nrSubOrdProd = widget.currentRow.NRSUBORDPROD;
       this.checkQueStstate();
    };
    
    this.sendChanges = function() {
        localStorageEngine.getDataSource('inspecaoQuestao', []).then(function(inspecaoQuestao) {
            localStorageEngine.getDataSource('respQuestVisBoo', []).then(function(respQuestVisBoo) {
                localStorageEngine.getDataSource('respQuestVar', []).then(function(respQuestVar) {
                    localStorageEngine.getDataSource('respQuestCad', []).then(function(respQuestCad) {

                        var rows = {};
                        rows[0] = inspecaoQuestao;
                        rows[1] = respQuestVisBoo;
                        rows[2] = respQuestVar;
                        rows[3] = respQuestCad;
                        rows[4] = cadRowsToDelete;
                        
                        for(var i=0; i < rows[0].length; i++) {
                            delete rows[0][i].TPQUESTCHECK;
                            delete rows[0][i].DSQUESTCHECK;
                        }
                        
                        QPR01900_Inspecao_Digital_Service.sendChanges(rows).then(function(success){
                            ScreenService.showMessage('Mudanças salvas com sucesso.');
                            
                            for(var i=0; i < rows.length; i++) {
                                for(var j=0; i < rows[i].length; j++) {
                                    rows[i][j].__is_new = false;
                                }
                            }
                            
                        });
                    }.bind(this));
                }.bind(this));
            }.bind(this));
        });
    };
    
    this.makeVisBooResp = function(type, idresp) {
        var newResp = {
            CDFILIAL: this.currentQuest.CDFILIAL,
            CDCHECKLIST: this.currentQuest.CDCHECKLIST,
            NRORDPROD: this.currentQuest.NRORDPROD,
            NRSUBORDPROD: this.currentQuest.NRSUBORDPROD,
            NRQUESTCHECK: this.currentQuest.NRQUESTCHECK,
            CDETAPAPROD: this.currentQuest.CDETAPAPROD,
            CDINSPECAO: this.currentQuest.CDINSPECAO,
            CDHABILIDADE: this.currentQuest.CDHABILIDADE,
            NRAUDITORIA: this.currentQuest.NRAUDITORIA,
            NRINSPECAUDI: this.currentQuest.NRINSPECAUDI,
            IDATIVO: this.currentQuest.IDATIVO,
            NRORG: this.currentQuest.NRORG,
            NRORGULTATU: this.currentQuest.NRORGULTATU,
            CDOPERULTATU: this.currentQuest.CDOPERULTATU,
            __is_new: true
        };
        
        if (type == 'Vis') {
            if (idresp == 1) {
                newResp.IDRESPVISTO = 'NOK';
            } else {
                newResp.IDRESPVISTO = 'SOK';
            }
        } else {
            if (idresp == 2) {
                newResp.IDVERDFALSO = 'N';
            } else {
                newResp.IDVERDFALSO = 'S';
            }
        }
        
        return newResp;
    };
    
    this.makeVarResp = function(valresp) {
        var newResp = {
            CDFILIAL: this.currentQuest.CDFILIAL,
            CDCHECKLIST: this.currentQuest.CDCHECKLIST,
            NRORDPROD: this.currentQuest.NRORDPROD,
            NRSUBORDPROD: this.currentQuest.NRSUBORDPROD,
            NRQUESTCHECK: this.currentQuest.NRQUESTCHECK,
            CDETAPAPROD: this.currentQuest.CDETAPAPROD,
            CDINSPECAO: this.currentQuest.CDINSPECAO,
            CDHABILIDADE: this.currentQuest.CDHABILIDADE,
            NRAUDITORIA: this.currentQuest.NRAUDITORIA,
            NRINSPECAUDI: this.currentQuest.NRINSPECAUDI,
            IDATIVO: this.currentQuest.IDATIVO,
            NRORG: this.currentQuest.NRORG,
            NRORGULTATU: this.currentQuest.NRORGULTATU,
            CDOPERULTATU: this.currentQuest.CDOPERULTATU,
            __is_new: true,
            VRRESPTAR: valresp
        };
        
        return newResp;
    };
    
    this.makeCadResp = function(widget, code) {
        var newResp = {
            CDFILIAL: this.currentQuest.CDFILIAL,
            CDCHECKLIST: this.currentQuest.CDCHECKLIST,
            NRORDPROD: this.currentQuest.NRORDPROD,
            NRSUBORDPROD: this.currentQuest.NRSUBORDPROD,
            NRQUESTCHECK: this.currentQuest.NRQUESTCHECK,
            CDETAPAPROD: this.currentQuest.CDETAPAPROD,
            NRINSPECAUDI: this.currentQuest.NRINSPECAUDI,
            CDHABILIDADE: this.currentQuest.CDHABILIDADE,
            CDINSPECAO: this.currentQuest.CDINSPECAO,
            NRAUDITORIA: this.currentQuest.NRAUDITORIA,
            CDRESPCAD: code,
            CDPRODUTO: widget.currentRow.CDPRODUTO,
            NMPRODUTO: widget.currentRow.NMPRODUTO,
            CDEQUIPPRO: widget.currentRow.CDEQUIPPRO,
            NMEQUIPPRO: widget.currentRow.NMEQUIPPRO,
            NRLOTEESTQ: widget.currentRow.NRLOTEESTQ,
            CDOPERADOR: widget.currentRow.CDOPERADOR,
            NMOPERADOR: widget.currentRow.NMOPERADOR,
            COL1: widget.currentRow.COL1,
            COL2: widget.currentRow.COL2,
            COL3: widget.currentRow.COL3,
            COL4: widget.currentRow.COL4,
            COL5: widget.currentRow.COL5,
            COL6: widget.currentRow.COL6,
            COL7: widget.currentRow.COL7,
            COL8: widget.currentRow.COL8,
            COL9: widget.currentRow.COL9,
            __is_new: true
        };
        
        return newResp;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('QPR01900_Inspecao_Digital_Controller', QPR01900_Inspecao_Digital_Controller);
});

// FILE: ./assets/js/controllers/cdp00200_tipo_composicao_produto_Controller.js
function cdp00200_tipo_composicao_produto_Controller (templateManager, restEngine, General, ScreenService, ZhFilterPreferences){
    
    this.openFilter = function(widget) {
		this.setFieldsGerais(widget);
		var rowsToSet = {};

		ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
	};

	this.setFieldsGerais = function(widget) {
		templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
	};
    
    this.atualizaData = function(field){
        field.setValue(moment().format('DD/MM/YYYY HH:mm:ss'));
    };
    
    this.reload = function(widget){
        widget.reload();
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp00200_tipo_composicao_produto_Controller', cdp00200_tipo_composicao_produto_Controller);
});

// FILE: ./assets/js/controllers/cdp00500_etapa_de_producao_Controller.js
function cdp00500_etapa_de_producao_Controller(cdp00500_etapa_de_producao_Service, ZHPromise, templateManager, restEngine, General, ScreenService, ZhFilterPreferences) {

    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};

        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };

    this.setFieldsGerais = function(widget) {
        templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
    };

    this.saveEtapa = function(widget) {
        if (widget.isValid()) {
            cdp00500_etapa_de_producao_Service.salvarEtapa(widget.currentRow).then(function(Success) {
                    if (widget.currentRow.__is_new) {
                        widget.reload().then(function() {
                            widget.list(true);
                            ScreenService.closeSwipe();
                        });
                    }
                    else {
                        widget.view();
                    }
                }.bind(this),
                function(callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                });
        }
    };

}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp00500_etapa_de_producao_Controller', cdp00500_etapa_de_producao_Controller);
});


// FILE: ./assets/js/controllers/cdp07600_periodicidade_da_producaoController.js
function cdp07600_periodicidade_da_producaoController(templateManager, restEngine, General, ScreenService, ZHPromise, ZhFilterPreferences) {



	this.openFilter = function(widget) {
		this.setFieldsGerais(widget);
		var rowsToSet = {};

		ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
	};

	this.getFilialLogada = function() {
		var filter = [{
			"name": "CDFILIAL",
			"operator": "=",
			"value": "FILIAL_LOGADA"
		}];
		return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
	};

	this.setFieldsGerais = function(widget) {
		templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
	};

	this.widgetSaveDiasDeProd = function(args) {
		var isNew = args.owner.widget.currentRow.__is_new;
		var widgetsToActivate = args.owner.widget.widgets;

		if (!args.owner.widget.currentRow.DIPRODUCAO) {
			ScreenService.showMessage("O valor do campo Dia não pode ser nulo e dever ser um valor entre 1 a " + args.owner.widget.getField('DIPRODUCAO').maxValue);
			return 0;
		}
		else {

			General.saveCrud(args.owner.widget).then(function(response) {
				if (!isNew) {
					General.modEdit(args.owner.widget);
					General.cancelModEdit(args);

					args.owner.widget.reload();
					widgetsToActivate.forEach(function(element) {
						if (args.owner.widget.name !== element.name) {
							element.enabled = true;
						}
					});
				}
				else {

					args.owner.widget.reload();
					widgetsToActivate.forEach(function(element) {
						if (args.owner.widget.name !== element.name) {
							element.enabled = true;
						}
					});
				}
			});
		}
	};

	this.widgetSave = function(args) {
		var isNew = args.owner.widget.currentRow.__is_new;
		var widgetsToActivate = args.owner.widget.widgets;
		General.saveCrud(args.owner.widget).then(function(response) {
			if (!isNew) {
				General.modEdit(args.owner.widget);
				General.cancelModEdit(args);

				widgetsToActivate.forEach(function(element) {
					if (args.owner.widget.name !== element.name) {
						element.enabled = true;
					}
				});
			}
			else {

				args.owner.widget.reload();
				widgetsToActivate.forEach(function(element) {
					if (args.owner.widget.name !== element.name) {
						element.enabled = true;
					}
				});
			}
		});
	};

	this.widgetEdit = function(widget) {
		widget.getField('DIPRODUCAO').readOnly = true;
		General.widgetEdit(widget);
	};

	this.editPeri = function(widget) {
		widget.widgets[0].enabled = false;
		widget.reload();
		General.edit(widget);
	};

	this.backOrCancel = function(args) {
		args.owner.widget.getField('DIPRODUCAO').readOnly = false;
		General.backOrCancel(args);
	};

	this.backOrCancelPeri = function(args) {
		General.changeWidgetAcessibility(args.owner.widget.widgets, true);
		General.backOrCancel(args);
	};

	this.validaDiproducao = function() {
		var gridDiaProducao = templateManager.container.getWidget('grid_dia_producao');
		var gridPeriodicidade = templateManager.container.getWidget('grid_periodicidade');
		if (gridPeriodicidade.getField('IDTIPODIAP').value() === 'S') {
			gridDiaProducao.getField('DIPRODUCAO').maxValue = 7;
			gridDiaProducao.fields[7].isVisible = true;
			gridDiaProducao.getField('IDOCORP01').isVisible = true;
			gridDiaProducao.getField('IDOCORP02').isVisible = true;
			gridDiaProducao.getField('IDOCORP03').isVisible = true;
			gridDiaProducao.getField('IDOCORP04').isVisible = true;
			gridDiaProducao.getField('IDOCORP05').isVisible = true;
		}
		else {
			gridDiaProducao.getField('DIPRODUCAO').maxValue = 31;
			gridDiaProducao.fields[7].isVisible = false;
			gridDiaProducao.getField('IDOCORP01').isVisible = false;
			gridDiaProducao.getField('IDOCORP02').isVisible = false;
			gridDiaProducao.getField('IDOCORP03').isVisible = false;
			gridDiaProducao.getField('IDOCORP04').isVisible = false;
			gridDiaProducao.getField('IDOCORP05').isVisible = false;
		}
	};

	this.validaDiproducaoValue = function(field) {
		if (parseInt(field.value()) < parseInt(field.minValue) || parseInt(field.value()) > parseInt(field.maxValue)) {
			field.setValue("");
		}
	};

}
Configuration(function(ContextRegister) {
	ContextRegister.register('cdp07600_periodicidade_da_producaoController', cdp07600_periodicidade_da_producaoController);
});


// FILE: ./assets/js/controllers/ger15600_setorController.js
function ger15600_setorController (ScreenService, templateManager, General){
	
	this.reload = function(){
		var widgetSetor = templateManager.container.getWidget('widgetSetor');
		widgetSetor.reload();
	};
	
	this.createSetor = function(widget) {
        widget.reload();
        widget.newRow();
        widget.currentRow.__is_new = true;
    };
    
    this.edit = function(widget){
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };
    
    this.cancel = function(widget){
        if(widget.currentRow.__is_new === true){
            widget.dataSource.data.pop();
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        this.reload();
    };
    
    this.verificaCodigo = function(){
        var codigo = templateManager.container.getWidget('widgetSetor').getField('CDSETOR').value();
        if(isNaN(codigo)){
            ScreenService.showMessage("O campo 'Setor' deve conter apenas números");
            templateManager.container.getWidget('widgetSetor').getField('CDSETOR').setValue('');
        }
    };
    
    this.salvar = function(widget){
        var codigo = templateManager.container.getWidget('widgetSetor').getField('CDSETOR').value();
        if(isNaN(codigo)){
            ScreenService.showMessage("O campo 'Setor' deve conter apenas números");
            templateManager.container.getWidget('widgetSetor').getField('CDSETOR').setValue('');
        }else{
            if(widget.isValid() == true){
                if(widget.currentRow.__is_new === false) widget.currentRow.oldSigla = widget.backupRow.SGSETOR;
                General.callRestEngine('cadCdp#/setor_departamento_centcust/save', 'Row', widget.currentRow).then(function(callback){
                    if (widget.currentRow.__is_new) {
    					widget.list(true);
    					ScreenService.goBack();
    					widget.reload();
    				} else {
    					widget.computeDescriptionOrder();
    					widget.view();
    				}
    				ScreenService.showMessage("Salvo com sucesso.");
                }).catch(function(callback){
                    if(callback.data.error.length > 0){
                        ScreenService.showMessage(callback.data.error);
                    }else{
                        ScreenService.showMessage("Sigla já cadastrada.");
                    }
                });
            }
        }
    };
      
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger15600_setorController', ger15600_setorController);
});

// FILE: ./assets/js/controllers/ger19100_classificacaoProdutoController.js
function ger19100_classificacaoProdutoController (ScreenService, templateManager, General, ZhFilterPreferences){
	
	this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        rowsToSet.CDFILIAL = getLocalVar("CDFILIAL");
        rowsToSet.NMFILIAL = getLocalVar("NMFILIAL");

        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };

    this.setFieldsGerais = function(widget) {
        templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
    };
	
	this.reload = function(){
		var widgetClassificacao = templateManager.container.getWidget('widgetClassificacao');
		widgetClassificacao.reload();
	};
	
	this.adicionar = function(widget) {
        widget.reload();
        widget.newRow();
        widget.currentRow.__is_new = true;
    };
    
    this.edit = function(widget){
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };
    
    this.cancel = function(widget){
        if(widget.currentRow.__is_new === true){
            widget.dataSource.data.pop();
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        this.reload();
    };
    
    this.salvar = function(widget){
        if(widget.isValid()){
            var codigoValido;
            var nomeValido;
            var countCodigo = 0;
            var countNome = 0;
            widget.dataSource.data.forEach(function(codigo){
                if(widget.currentRow.CDCLATERAP == codigo.CDCLATERAP){
                    codigoValido = false;
                    countCodigo++;
                }if(widget.currentRow.NMCLATERAP == codigo.NMCLATERAP){
                    nomeValido = false;
                    countNome++;
                }
            });
            if(widget.currentRow.__is_new == true){
                if(codigoValido == false){
                    ScreenService.showMessage("Código já cadastrado.");
                }else if(nomeValido == false){
                    ScreenService.showMessage("Classificação do produto já cadastrada.");
                }else{
                    General.saveCrud(widget);
                }
            }else{
                if((countCodigo == 1) && (countNome == 1)){
                    General.saveCrud(widget);
                }else if(countNome > 1){
                    ScreenService.showMessage("Classificação do produto já cadastrada.");
                }
            }
        }
    };
    
    this.verificaCodigo = function(){
        var widget = templateManager.container.getWidget('widgetClassificacao');
        var codigoValido;
        widget.dataSource.data.forEach(function(codigo){
            if(widget.currentRow.CDCLATERAP == codigo.CDCLATERAP){
                codigoValido = false;
            }
        });
        
        if(codigoValido == false){
            ScreenService.showMessage("Código já cadastrado");
        }
    };
      
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger19100_classificacaoProdutoController', ger19100_classificacaoProdutoController);
});

// FILE: ./assets/js/controllers/gql00400_tipo_de_riscoController.js
function gql00400_tipo_de_riscoController (ScreenService, templateManager, General, ZhFilterPreferences){
	
	this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        rowsToSet.CDFILIAL = getLocalVar("CDFILIAL");
        rowsToSet.NMFILIAL = getLocalVar("NMFILIAL");

        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };

    this.setFieldsGerais = function(widget) {
        templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('gql00400_tipo_de_riscoController', gql00400_tipo_de_riscoController);
});

// FILE: ./assets/js/controllers/qpr00700_Especie_AnimalController.js
function qpr00700_Especie_AnimalController (ScreenService, templateManager, General, ZhFilterPreferences){
	
	this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        rowsToSet.CDFILIAL = getLocalVar("CDFILIAL");
        rowsToSet.NMFILIAL = getLocalVar("NMFILIAL");

        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };

    this.setFieldsGerais = function(widget) {
        templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('qpr00700_Especie_AnimalController', qpr00700_Especie_AnimalController);
});
